{$A-,B-,D+,E-,F-,I-,L+,N-,O-,R-,S-,V- }
{$M 16384,0,655360 }

{ SOURCE ECRIT PAR T.JAOUEN }

program simul;

procedure ChangeTask; forward;

type TaskRec = record
                 St  : byte;
                 SP  : word;
                 SS  : word;
                 BP  : word;
                 points : pointer;
               end;

const MxTask   = 10; (* 11 tche maximun (on ne compte pas la tche 0) *)
      LgStack  = 8192; (* taille d'une pile de tche autre que 0 *)
      TaskOFF  = 0;   (* tche dsactiv *)
      TaskStB  = 64;  (* tche en attente d'activit *)
      TaskON   = 128; (* tche active    *)
      TaskNull = 192; (* tche interdite *)

var TabTask : array[0..MxTask] of TaskRec;
    NumTask : byte;
    ADRSTACK: pointer;
    VARSP   : word;
    VARSS   : word;
    VARBP   : word;

type
  PtrRec = record
             Ofs, Seg : word;
           end;

procedure MsgTask(texte : string);
begin
  writeln('[',NumTask:2,']: ',texte);
end;

procedure GetMemStack(var point, adrreel : pointer; taille : word);
(* alloue de la mmoire pour une nouvelle pile,
   ajuste le pointer renvoy,
   c'est  dire, SS:0000 pointe sur un paragraphe
 *)
begin
  Inc(taille,16); (* toujours *)
  getmem(point,taille); (* point est normalis *)
  adrreel := point;
  if PtrRec(adrreel).Ofs<>0 then adrreel := ptr(PtrRec(adrreel).Seg+1,0);
end;

procedure parici( i : word);
begin
  if i mod 41=0 then MsgTask('coucou');
  ChangeTask;
end;

procedure mainx;
var i : word; { <--- variable dynamique propre a chaque 'tache' }
begin
  MsgTask('Nouvelle tche');
  i := 0;
  repeat
    inc(i);
    ChangeTask; { changement de tache }
    if NumTask mod 2=0 then parici(i); (* histoire de varier... *)
  until i>500;
  MsgTask('Fin de tche');
end;

procedure GetStack;
inline( $89/$2E/VARBP/  { mov VARBP, bp }
        $89/$26/VARSP/  { mov VARSP, sp }
        $8C/$D0/        { mov ax, ss    }
        $A3/VARSS       { mov VARSS, ax }
        );

procedure SetStack;
inline( $FA/            { cli           }
        $8B/$2E/VARBP/  { mov bp, VARBP }
        $8B/$26/VARSP/  { mov sp, VARSP }
        $A1/VARSS/      { mov ax, VARSS }
        $8E/$D0/        { mov ss, ax    }
        $FB             { sti           }
        );

procedure ChangeTask;
begin
  (* sauve SS:SP -> TabTask[NumTask] *)
  GetStack; { saisie l'etat de la pile, et sauvegarde }
  TabTask[NumTask].SS := VARSS;
  TabTask[NumTask].SP := VARSP;
  TabTask[NumTask].BP := VARBP;
  repeat
    Inc(NumTask);
    if NumTask>MxTask then NumTask := 0;
    case (TabTask[NumTask].St and 192) of
      TaskStB : begin (* tache en stand-by a lanc *)
                      (* de pile NumTask -> SS:SP *)
                GetMemStack(TabTask[NumTask].points,ADRSTACK,LgStack);
                VARSS := PtrRec(ADRSTACK).Seg;
                VARSP := LgStack;
                SetStack;
                TabTask[NumTask].SS := VARSS;
                TabTask[NumTask].SP := VARSP;
                TabTask[NumTask].St := TaskON; { indique la tache active }
                mainx; { lancement de la tache }
                TabTask[NumTask].St := TaskOFF;
                FreeMem(TabTask[NumTask].points,LgStack+16);
                (* TabTask[0] -> SS:SP *)
                (* fin de tache *)
                end;
      TaskON : begin { tache active }
               (* TabTask[NumTask] -> SS:SP *)
               VARSS := TabTask[NumTask].SS;
               VARSP := TabTask[NumTask].SP;
               VARBP := TabTask[NumTask].BP;
               SetStack;
               exit; { reprend l'execution de la tache }
               end;
    end; (* case of *)
  until false; (* boucle infinie *)
end;

procedure main;
(* la procedure de la tche 0 *)
(* cette tache est particuliere puisqu'elle est en fait la tache pere de *)
(* toutes les autres. On doit commmencer et finir par elle. *)
(* sa pile est celle dfinie a la compilation $M... *)
var i : word;
begin
  MsgTask('Multitche en cours...');
  i := 0;
  repeat
    inc(i);
    ChangeTask;   { effectue le changement de tache }
  until (i>1000);
  MsgTask('Fin de toutes les tches');
end;

var i : word;
begin
  NumTask := 0;  (* la tche active est la 0 *)
  TabTask[0].St := TaskON; { tache 0 toujours active }
  for i:=1 to MxTask do
    begin
      TabTask[i].St := TaskOFF; { initialise }
    end;
  TabTask[1].St := TaskStB; { indique que la 'tache' est en attente }
  TabTask[5].St := TaskStB; { elle sera lanc lorsque son tour viendra }
  TabTask[7].St := TaskStB; { et par la procedure ChangeTask }
  TabTask[8].St := TaskStB;
  main;
end.
