{$A+,B-,E-,F-,I-,N-,O-,V- }

{$IFDEF DEBUG }
  {$R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }
{$M 4096, 0, 655360 }


program Simul3;

uses Dos,Crt;

const MemHeadMark = $E2E4; { marque d'integrit de struc. (si alloue) }
      MemFreeMark = $A1A2; { marque d'integrit de struc. (si libre) }
      EmsOfsNIL   = $FFFF; { decalage sans suite, pour Ems }

type PEMSAllocRec = ^EMSAllocRec;

     EMSAllocRec = record
         HeadMark  : word;     { marque d'integrit de structure }
         Level     : longint;  { nd'ordre d'entre }
         Prec      : word;     { offset relatif au PF donnes (EmsOfsNIL=>rien) }
         Next      : word;     { idem (Prec<Next) }
         Lg        : word;     { longueur espace mmoire }
         CheckSum  : word;     { pour le mode DEBUG }
         EndMark   : word;     { marque d'integrit de structure }
       end;

     TaskEMSRec = record
         PF         : array[0..3] of word;  { etat page frame }
         MemAvail   : word;     { mmoire libre (max:28 Ko) }
         FirstAlloc : word;     { premiere allocation }
         LastAlloc  : word;     { dernire ... }
         NbAlloc    : word;     { nombre d'allocation }
       end;


     TaskMode = (TaskOFF,TaskStandBY,TaskON);

     TaskRec = record
         St         : TaskMode;

         SS         : word;     { si EMS, SS est constant  toutes les tches }
         SP         : word;
         BP         : word;

         PF         : array[0..3] of word;  { etat page frame }
         MemAvail   : word;     { mmoire libre (max:28 Ko) }
         FirstAlloc : word;     { premiere allocation }
         LastAlloc  : word;     { dernire ... }
         NbAlloc    : word;     { nombre d'allocation }
       end;

     PTaskRec = ^TaskRec;


const LgTabTask = 32;

var TabTask : array[0..LgTabTask-1] of TaskRec;

    NbTask     : word;        { nombre total de tches }
    NumTask    : word;        { n de la tche courante }
    _Task_     : PTaskRec;    { structure de la tche courante }
    NbTaskON   : word;        { nombre de tches actives }

    LgStack    : word;        { taille de la pile d'une tche }
    LcGranule  : word;        { Taux de granularit: 0,1,3,... }

    VARSS      : word;        { variables de transfert }
    VARSP      : word;
    VARBP      : word;

    BasicSS    : word;        { etat de la pile orginel }
    BasicSP    : word;
    BasicBP    : word;


const IntrEMS  = $67;

var EmsHandle   : word;        { Handle EMS en fonction de la mem alloue }
    EmsSysSeg   : word;        { Segment/Page rserv  Zedix }
    EmsPgSeg    : word;        { Segment/Page rserv aux pages locales }
    EmsDataSeg  : word;        { Segment/Page rserv aux donnes locales }
    EmsSS       : word;        { SS de la pile tche }
    EmsNbPages  : word;        { nombre de pages alloues }



procedure ChangeTask; forward;  { ---- voir plus loin }


{ --------------------------------
  Messages affichs par les tches
  -------------------------------- }
procedure MsgTask( texte : string );
begin
  writeln('[',NumTask:2,']: ',texte);
end;


{ ----------------------------------
  Renvoi la mmoire local disponible
  ---------------------------------- }
function ixLcMemAvail : word;
begin
  ixLcMemAvail := _Task_^.MemAvail;
end;


{ -------------------------------------------
  Recherche en Ems/Mem-Local une partie libre
  ------------------------------------------- }
procedure GetEmsMem( var Ofs : word;         { position debut libre }
                     var BA  : PEmsAllocRec; { structure suivant la pos. (nil=>fin) }
                     size    : word );       { longueur minimun recherch }
{ -----------------------------------
  Ofs=EmsOfsNIL si pas assez de place
  ----------------------------------- }
type PtrRec = record Ofs, Seg : word; end;
var g : word;
    d : word;
    h : PEmsAllocRec;
begin
  d := 0;
  PtrRec(h).Seg := EmsDataSeg;
  g := _Task_^.FirstAlloc;

  while g<>EmsOfsNIL do
    begin
      PtrRec(h).Ofs := g;
      if g-d>=size then
        begin
          { ---------------------
            zone libre suffisante
            --------------------- }
          if (h^.HeadMark=MemHeadMark) and
             (h^.EndMark=MemHeadMark) then
            begin
              Ofs := d;
              BA  := h;
            end
          else
            begin
              Ofs := EmsOfsNIL;
              BA  := h; { il y a erreur=>plus de mem }
            end;
          exit;
        end;
      d := g+sizeof(EmsAllocRec)+h^.Lg;
      g := h^.Next;
    end;

  if (32768-LgStack)-d>=size then
    begin
      Ofs := d;
      BA  := nil;    { nil => la derniere structure }
    end
  else
    begin
      Ofs := EmsOfsNIL;  { rien }
      BA  := nil;        { absolument rien }
    end;
end;


{ -------------------------------
  Alloue un bloc de mmoire local
  ------------------------------- }
function ixLcAlloc( var p : pointer; size : word ) : boolean;
type PtrRec = record Ofs, Seg : word; end;
var a : pointer;
    x : longint;
    o : word;
    h : PEmsAllocRec;
    l : PEmsAllocRec;
    n : PEmsAllocRec;
begin
  size := (size+LcGranule) and not(LcGranule);
  if (size>0) and (size<$FFFF-sizeof(EmsAllocRec)) and
     (_Task_^.MemAvail>=sizeof(EmsAllocRec)+size) then
    begin
      GetEmsMem(o,h,size+sizeof(EmsAllocRec));
      if o<>EmsOfsNIL then
        begin
          n := ptr(EmsDataSeg,o);
          FillChar(n^,sizeof(n^),0);
          n^.HeadMark := MemHeadMark;
          n^.Level    := 0;
          if h=nil then
            begin
              if _Task_^.LastAlloc=EmsOfsNIL then
                begin
                  _Task_^.FirstAlloc := o;
                  n^.Prec := EmsOfsNIL;
                end
              else
                begin
                  l := ptr(EmsDataSeg,_Task_^.LastAlloc);
                  l^.Next := o;
                  n^.Prec := PtrRec(l).Ofs;
                end;
              _Task_^.LastAlloc := o;
              n^.Next := EmsOfsNIL;
            end
          else
            begin
              if h^.Prec=EmsOfsNIL then
                begin
                  _Task_^.FirstAlloc := o;
                  n^.Prec := EmsOfsNIL;
                end
              else
                begin
                  l := ptr(EmsDataSeg,h^.Prec);
                  l^.Next := o;
                  n^.Prec := PtrRec(l).Ofs;
                end;
              h^.Prec := o;
              n^.Next := PtrRec(h).Ofs;
            end;
          n^.Lg       := size;
          n^.CheckSum := 0;
          n^.EndMark  := MemHeadMark;

          inc(_Task_^.NbAlloc);
          dec(_Task_^.MemAvail,size+sizeof(EmsAllocRec));

          x := (longint(PtrRec(n).Seg) shl 4)+
               longint(PtrRec(n).Ofs)+sizeof(EmsAllocRec);
                 { --- adresse reel }
          PtrRec(a).Seg := word(x shr 4);
          PtrRec(a).Ofs := word(x) and 15;  { --- adresse standardis }
        end
      else a := nil; { plus ou pas assez de mmoire }
    end
  else a := nil;
  p := a;
  ixLcAlloc := a<>nil;
end;



{ ------------------------
  Libere la mmoire locale
  ------------------------ }
procedure ixLcFree( var p : pointer );
{ -----------------------------------
  Le pointer est toujours renvoy NIL
  ----------------------------------- }
type PtrRec = record Ofs, Seg : word; end;
var a : pointer;
    x : longint;
    o : word;
    n : PEmsAllocRec;
begin
  a := p;
  if a<>nil then
    begin
      x := (longint(PtrRec(a).Seg) shl 4)+
           longint(PtrRec(a).Ofs);             { --- adresse reel }
      PtrRec(a).Seg := word(x shr 4);
      PtrRec(a).Ofs := word(x) and 15;          { --- adresse standardis }

      { -------------------------
        Adresse bien en PF Data ?
        ------------------------- }
      if (PtrRec(a).Seg>=EmsDataSeg) and
         (PtrRec(a).Seg<EmsSS) then
        begin { --- Oui }
          { ----------------------------------------
            position de la structure de base mmoire
            ---------------------------------------- }
          o := ((PtrRec(a).Seg-EmsDataSeg)*16+PtrRec(a).Ofs)-
               sizeof(EmsAllocRec);
          n := ptr(EmsDataSeg,o);
          if (n^.HeadMark=MemHeadMark) and
             (n^.EndMark=MemHeadMark) then
            begin
              n^.HeadMark := MemFreeMark;
              n^.EndMark  := MemFreeMark;
              if n^.Prec<>EmsOfsNIL then
                EmsAllocRec(ptr(EmsDataSeg,n^.Prec)^).Next := n^.Next
              else _Task_^.FirstAlloc := n^.Next;
              if n^.Next<>EmsOfsNIL then
                EmsAllocRec(ptr(EmsDataSeg,n^.Next)^).Prec := n^.Prec
              else _Task_^.LastAlloc := n^.Prec;
              dec(_Task_^.NbAlloc);
              inc(_Task_^.MemAvail,n^.Lg+sizeof(EmsAllocRec));
            end;
        end;
      p := nil;
    end;
end;


{ ---------------------------------------------------------
  Renvoi le niveau de fragmentation de la mmoire local
  (renvoi toujours "0" si la mmoire local est dans le tas)
  --------------------------------------------------------- }
function ixLcFrag : word;
type PtrRec = record Ofs, Seg : word; end;
var g : word;
    d : word;
    h : PEmsAllocRec;
    n : word;
begin
  n := 0;
  d := 0;
  PtrRec(h).Seg := EmsDataSeg;
  g := _Task_^.FirstAlloc;
  while g<>EmsOfsNIL do
    begin
      PtrRec(h).Ofs := g;
      if g-d>0 then inc(n);
      d := g+sizeof(EmsAllocRec)+h^.Lg;
      g := h^.Next;
    end;
  ixLcFrag := n;
end;



{ --------------------------
  Renvoi un nombre en chaine
  -------------------------- }
function StrVal( x : longint ) : string;
var s : string[20];
begin
  Str(x,s);
  StrVal := s;
end;


procedure _ShowAlloc;
type PtrRec = record Ofs, Seg : word; end;
var h : PEmsAllocRec;
    g : word;
    d : word;
    l : word;
    c : word;
begin
  TextAttr := $07;
  ClrScr;

  GotoXY(1,1);
  TextAttr := $07;
  writeln('ixLcMemAvail=',ixLcMemAvail:5);
  writeln('    ixLcFrag=',ixLcFrag:5);
  writeln('     NbAlloc=',_Task_^.NbAlloc:5);
  g := _Task_^.LastAlloc;
  if g=$FFFF then writeln
  else
    begin
      h := ptr(EmsDataSeg,g);
      writeln('         Top=',g+h^.Lg+sizeof(EmsAllocRec):5);
    end;
  writeln('  EmsDataSeg=',EmsDataSeg:5);

  d := 0;
  l := 0;
  c := 18;
  PtrRec(h).Seg := EmsDataSeg;
  g := _Task_^.FirstAlloc;
  while g<>EmsOfsNIL do
    begin
      PtrRec(h).Ofs := g;
      if g-d>0 then
        begin
          GotoXY(c+1,l+1);
          TextAttr := $0F;
          write('|');
          TextAttr := $07;
          write(g-d:5);
          inc(l);
          if l>24 then
            begin
              l := 0;
              inc(c,6);
            end;
        end;
      GotoXY(c+1,l+1);
      TextAttr := $0F;
      write('|');
      TextAttr := $70;
      write(sizeof(EmsAllocRec)+h^.Lg:5);
      inc(l);
      if l>24 then
        begin
          l := 0;
          inc(c,6);
        end;

      d := g+sizeof(EmsAllocRec)+h^.Lg;
      g := h^.Next;
    end;
end;



procedure ShowAlloc;
type PtrRec = record Ofs, Seg : word; end;
var n : PEmsAllocRec;
    d : word;
begin
  PtrRec(n).Seg := EmsDataSeg;
  d := _Task_^.FirstAlloc;
  while d<>EmsOfsNIL do
    begin
      PtrRec(n).Ofs := d;
      if (n^.HeadMark=MemHeadMark) and
         (n^.EndMark=MemHeadMark) then
        begin
          MsgTask('Alloc en '+StrVal(d)+' de '+StrVal(n^.Lg)+' octets');
          d := n^.Next;
        end
      else
        begin
          MsgTask('Invalide struc.');
          d := EmsOfsNIL;
        end;
    end;
  MsgTask('--- Fin Alloc. '+StrVal(ixLcMemAvail));
end;



{ ----------
  La tche 0
  ---------- }
procedure ProcessTask0;
var i : word;
begin
  MsgTask('Multitche en cours... '+StrVal(MemAvail)+'/'+StrVal(ixLcMemAvail));

  for i := 1 to 100 do ChangeTask;

  if NbTaskON>1 then
    begin
      MsgTask('Il existe encore des tches en cours...');
      while (NbTaskON>1) and not(KeyPressed) do ChangeTask;
    end;

  MsgTask('Fin de toutes les tches.'+StrVal(ixLcMemAvail)+' Frag='+StrVal(ixLcFrag));
end;



(*
procedure ProcessTask0;

  procedure ShowAlloc;

    procedure WithEms;
    type PtrRec = record Ofs, Seg : word; end;
    var h : PEmsAllocRec;
        g : word;
        d : word;
        l : word;
        c : word;
    begin
      TextAttr := $07;
      ClrScr;

      GotoXY(1,1);
      TextAttr := $07;
      writeln('ixLcMemAvail=',ixLcMemAvail:5);
      writeln('    ixLcFrag=',ixLcFrag:5);
      writeln('     NbAlloc=',_Task_^.Ems.NbAlloc:5);
      g := _Task_^.Ems.LastAlloc;
      if g=$FFFF then writeln
      else
        begin
          h := ptr(EmsDataSeg,g);
          writeln('         Top=',g+h^.Lg+sizeof(EmsAllocRec):5);
        end;
      writeln('  EmsDataSeg=',EmsDataSeg:5);

      d := 0;
      l := 0;
      c := 18;
      PtrRec(h).Seg := EmsDataSeg;
      g := _Task_^.Ems.FirstAlloc;
      while g<>EmsOfsNIL do
        begin
          PtrRec(h).Ofs := g;
          if g-d>0 then
            begin
              GotoXY(c+1,l+1);
              TextAttr := $0F;
              write('|');
              TextAttr := $07;
              write(g-d:5);
              inc(l);
              if l>24 then
                begin
                  l := 0;
                  inc(c,6);
                end;
            end;
          GotoXY(c+1,l+1);
          TextAttr := $0F;
          write('|');
          TextAttr := $70;
          write(sizeof(EmsAllocRec)+h^.Lg:5);
          inc(l);
          if l>24 then
            begin
              l := 0;
              inc(c,6);
            end;

          d := g+sizeof(EmsAllocRec)+h^.Lg;
          g := h^.Next;
        end;
    end;

    procedure WithoutEms;
    begin
    end;

  begin
    if EmsON then WithEms else WithoutEms;
  end;


const LgT = 300;
      MxSize = 256;

var t : array[1..LgT] of pointer;

var i : word;
    nb : word;
    n : word;
    l : word;
    c : char;
    Wait : boolean;
    nbtest : word;
    nbget  : word;
    nbfree : word;
    lg     : word;
begin
  Randomize;

  for i := 1 to LgT do t[i] := nil;

  Wait := FALSE;

  nb := 0;
  nbget := 0;
  nbfree := 0;
  nbtest := 0;
  c := ' ';
  while UpCase(c)<>'Q' do
    begin
      n := Random(LgT)+1;
      if t[n]=nil then
        begin
          lg := Random(MxSize);
          if lg=0 then lg := 1;
          if ixLcAlloc(t[n],lg) then
            begin
              inc(nbget);
              inc(nb);
            end
          else
            begin
              sound(2000);
              delay(200);
              nosound;
              Wait := TRUE;
            end;
        end
      else
        if ((_Task_^.Ems.NbAlloc*100) div LgT)>=0 then
        begin
          inc(nbfree);
          ixLcFree(t[n]);
          t[n] := nil;
          dec(nb);
        end;
      inc(nbtest);
      ShowAlloc;

      if KeyPressed or Wait then
        begin

          {
          GotoXY(1,1);
          writeln('Fragment=',ixLcFrag:10);
          writeln('Nbtest  =',nbtest:10);
          writeln('Nb      =',nb:10);
          writeln('MemAvail=',ixLcMemAvail:10);
          writeln('MaxAvail=',MaxAvail:10);
          writeln('NbGet   =',nbget:10);
          writeln('NbFree  =',nbfree:10);
          for i := 1 to LgT do
            if t[i]<>nil then SetMem(i,1) else SetMem(i,0);
          }
          if KeyPressed then c := ReadKey;
          repeat
          until KeyPressed;
          ClrScr;
          c := ReadKey;
          Wait := FALSE;
        end;
    end;


  MsgTask('Fin de toutes les tches.'+StrVal(ixLcMemAvail)+' Frag='+StrVal(ixLcFrag));

  for i := 1 to LgT do ixLcFree(t[i]);

  MsgTask('Bis: '+StrVal(ixLcMemAvail)+' Frag='+StrVal(ixLcFrag));
end;
*)



{ ---------------
  Les tches (>0)
  --------------- }
procedure ProcessTaskX;
const LgT = 1000;

type TRec = record
         p  : pointer;
         lg : word;
       end;

     Buffer = array[1..10000] of byte;

var i : word;
    t : array[1..LgT] of TRec;
    n : word;
    lg : word;
    j : word;
begin
  Randomize;

  for i := 1 to LgT do
    begin
      t[i].p  := nil;
      t[i].lg := 0;
    end;

  MsgTask('Nouvelle tche... '+StrVal(MemAvail div 1024)+' Ko Free et '+
          StrVal(ixLcMemAvail));
  for i := 1 to 80 do
    begin
      n := Random(LgT)+1;
      if t[n].p=nil then
        begin
          lg := Random(512)+1;
          if ixLcAlloc(t[n].p,lg) then
            begin
              t[n].lg := lg;
              FillChar(t[n].p^,lg,byte(n));
            end;
        end
      else
        begin
          ixLcFree(t[n].p);
          t[n].p  := nil;
          t[n].lg := 0;
        end;
      ChangeTask;
    end;
  MsgTask('Fin de tche. '+StrVal(MemAvail div 1024)+' Ko Free ('+StrVal(ixLcMemAvail)+')');

  for i := 1 to LgT do
    if t[i].p<>nil then
      begin
        for j := 1 to t[i].lg do
          if Buffer(t[i].p^)[j]<>byte(i) then
            begin
              MsgTask('i='+StrVal(i)+' j='+StrVal(j));
              sound(2000);
              delay(200);
              nosound;
              j := t[i].lg;
              i := LgT;
            end;
      end;
end;



{ ----------------------------
  Mettre en place une page EMS
  ---------------------------- }
procedure SetEmsPage( PFx, nPage : word );
var reg : registers;
begin
  reg.AH := $44;
  reg.AL := PFx;
  reg.BX := nPage;
  reg.DX := EmsHandle;
  Intr(IntrEMS,reg);
  _Task_^.PF[PFx] := nPage;  { note }
end;



{ ----------------------------------
  Alloue de la mmoire pour une pile
  ---------------------------------- }
procedure GetMemStack( var SegStack : word;      { segment de la pile }
                       var AdrReel  : pointer;   { adresse reel de l'allocation }
                       Taille       : word       { taille voulu }
                     );
type PtrRec = record
         Ofs, Seg : word;
       end;
begin
  GetMem(AdrReel,Taille+16);  { --- +16 : Attention ! }
  if PtrRec(AdrReel).Ofs<>0 then SegStack := PtrRec(AdrReel).Seg+1
  else SegStack := PtrRec(AdrReel).Seg;
end;



{ -----------------------------------
  Recherche l'etat courant de la pile
  ----------------------------------- }
procedure GetStackRegs;
inline( $89/$2E/VARBP/  { mov VARBP, bp }
        $89/$26/VARSP/  { mov VARSP, sp }
        $8C/$D0/        { mov ax, ss    }
        $A3/VARSS       { mov VARSS, ax }
        );


{ -------------------------------
  Fixe l'etat de la pile courante
  ------------------------------- }
procedure SetStackRegs;
inline( $FA/            { cli           }
        $8B/$2E/VARBP/  { mov bp, VARBP }
        $8B/$26/VARSP/  { mov sp, VARSP }
        $A1/VARSS/      { mov ax, VARSS }
        $8E/$D0/        { mov ss, ax    }
        $FB             { sti           }
        );



{ -------------------------------
  Effectue le changement de tche
  ------------------------------- }
procedure ChangeTask;
begin
  { ---------------------------------
    Sauvegarde le contexte de la pile
    --------------------------------- }
  GetStackRegs;
  _Task_^.SS := VARSS;
  _Task_^.SP := VARSP;
  _Task_^.BP := VARBP;

  { --------------------------------------------------
    On se place sur une pile stable (la pile standard)
    -------------------------------------------------- }
  VARSS := BasicSS;
  VARSP := BasicSP;
  VARBP := BasicBP;
  SetStackRegs;

  while TRUE do
    begin
      inc(NumTask);
      if NumTask>=NbTask then NumTask := 0;
      _Task_ := @TabTask[NumTask];
      case _Task_^.St of
        TaskStandBy :
          begin

            inc(NbTaskON);

            { -------------------------------
              Activation d'une nouvelle tche
              ------------------------------- }
            FillChar(_Task_^,sizeof(_Task_^),0);
            _Task_^.St := TaskON;
            SetEmsPage(0,_Task_^.PF[0]);
            SetEmsPage(1,_Task_^.PF[1]);
            SetEmsPage(2,NumTask*2);
            SetEmsPage(3,NumTask*2+1);
            _Task_^.SS := EmsSS;

            _Task_^.FirstAlloc := EmsOfsNIL;
            _Task_^.LastAlloc  := EmsOfsNIL;
            _Task_^.MemAvail   := 32768-LgStack;

            _Task_^.SP := LgStack;
            _Task_^.BP := LgStack;

            { -------------
              Nouvelle pile
              ------------- }
            VARSS := _Task_^.SS;
            VARSP := _Task_^.SP;
            VARBP := _Task_^.BP;
            SetStackRegs;

            ProcessTaskX;

            { --------------------------------------------------
              On se place sur une pile stable (la pile standard)
              -------------------------------------------------- }
            VARSS := BasicSS;
            VARSP := BasicSP;
            VARBP := BasicBP;
            SetStackRegs;

            _Task_^.St := TaskOFF;
            dec(NbTaskON);

          end;
        TaskON :
          begin
            { ---------------
              Replace la pile
              --------------- }
            SetEmsPage(0,_Task_^.PF[0]);
            SetEmsPage(1,_Task_^.PF[1]);
            SetEmsPage(2,NumTask*2);
            SetEmsPage(3,NumTask*2+1);

            { ------------
              Fixe la pile
              ------------ }
            VARSS := _Task_^.SS;
            VARSP := _Task_^.SP;
            VARBP := _Task_^.BP;
            SetStackRegs;

            exit;    { --- et on repart }
          end;
        TaskOFF : ;  { --- rien }
      end;
    end;
end;



{ ----------------------------
  Initialisation de la tche 0
  ---------------------------- }
procedure InitTask0;
begin
  { -------------------------------------
    On conserve l'etat courant de la pile
    (on s'en servira plus tard)
    ------------------------------------- }
  GetStackRegs;
  BasicSS := VARSS;
  BasicSP := VARSP;
  BasicBP := VARBP;


  { -----------------------------------
    Initialise la tche 0: Pile, etc...
    ----------------------------------- }
  NbTaskON   := 1;
  NumTask    := 0;
  _Task_     := @TabTask[0];
  FillChar(_Task_^,sizeof(_Task_^),0);
  _Task_^.St := TaskON;
  SetEmsPage(0,0);  { --- pour initialiser }
  SetEmsPage(1,0);  { ... }
  SetEmsPage(2,0);  { donnes tche 0 }
  SetEmsPage(3,1);  { pile tche 0 }

  _Task_^.FirstAlloc := EmsOfsNIL;
  _Task_^.LastAlloc  := EmsOfsNIL;
  _Task_^.MemAvail   := 32768-LgStack;
  _Task_^.SS := EmsSS;

  _Task_^.SP := LgStack;
  _Task_^.BP := LgStack;

  { -------------
    Nouvelle pile
    ------------- }
  VARSS := _Task_^.SS;
  VARSP := _Task_^.SP;
  VARBP := _Task_^.BP;
  SetStackRegs;

  ProcessTask0;    { --- depart de la tche 0 }

  { ------------------------------------
    On restaure l'etat normal de la pile
    ------------------------------------ }
  VARSS := BasicSS;
  VARSP := BasicSP;
  VARBP := BasicBP;
  SetStackRegs;

end;


var SaveExit : pointer;

{$F+}
procedure FreeEms;
{$F-}
var reg : registers;
begin
  ExitProc := SaveExit;
  { -------------------------
    Libere la memoire alloue
    ------------------------- }
  reg.AH := $45;
  reg.DX := EMSHandle;
  Intr(IntrEMS,reg);

  writeln('EMS libre');
end;


function EmsOpen : boolean;
var reg      : registers;
    NbPages  : word;    { nombre de page EMS disponible }
    Ver      : word;    { n version EMS }
    SubVer   : word;    { n sous version }
    MinPages : word;
begin
  EmsOpen := FALSE;   { --- par dfaut }

  { -----------------------------
    Verifier l'existence de l'EMS
    (En fait, ca plante s'il n'y
     a pas d'EMS !!!)
    ----------------------------- }
  reg.AH := $40;
  Intr(IntrEMS,reg);
  if reg.AH=0 then
    begin
      { -------------------------
        Dterminer la version EMS
        ------------------------- }
      reg.AH := $46;
      Intr(IntrEMS,reg);
      Ver    := reg.AL shr 4;
      SubVer := reg.AL and 15;

      { ------------------------------------
        On admet que les versions EMS >= 3.2
        ------------------------------------ }
      if (Ver>3) or ((Ver=3) and (SubVer>=2)) then
        begin
          { --------------------------------------------
            Determiner le nombre de pages EMS disponible
            -------------------------------------------- }
          reg.AH := $42;
          Intr(IntrEMS,reg);
          NbPages := reg.BX;
          { -----------------------------------------------------
            On s'assure que l'EMS peut repondre au besoin minimun
            ----------------------------------------------------- }

          MinPages := (NbTask*2);    { --- 2 pages minimun par tches }

          if NbPages>=MinPages then
            begin
              { -------------------------------
                Allocation de cette memoire EMS
                ------------------------------- }
              reg.AH := $43;
              reg.BX := MinPages;
              EmsNbPages := MinPages;   { --- note }
              Intr(IntrEMS,reg);
              if reg.AH=0 then
                begin
                  EmsHandle := reg.DX;  { --- garde le Handle }

                  { ----------------------------------------
                    Code de sortie, en cas d'arret d'urgence
                    ---------------------------------------- }
                  SaveExit := ExitProc;
                  ExitProc := @FreeEms;

                  { ----------------------------------
                    Recherche du segment de Page Frame
                    ---------------------------------- }
                  reg.AH := $41;
                  reg.DX := EmsHandle;
                  Intr(IntrEMS,reg);
                  EmsSysSeg  := reg.BX;
                  EmsPgSeg   := reg.BX+1024;
                  EmsDataSeg := reg.BX+2048;
                  EmsSS      := reg.BX+4096-(LgStack div 16);
                  writeln('EMS v',Ver,'.',SubVer,'  Handle:',EMSHandle,
                          '   ',EMSNbPages,
                          ' pages (',longint(EMSNbPages)*16,' Ko)');

                  EmsOpen := TRUE;
                end
              else writeln('Impossible d''allouer de la mmoire EMS ! (',reg.AH,')');
            end
          else writeln('Mmoire EMS trop rduite: ',
                       longint(NbPages)*16,' Ko  au lieu de ',
                       longint(MinPages)*16,' Ko');
        end
      else writeln('Version trop ancienne ! (v',Ver,'.',SubVer,')');
    end
  else writeln('Pas d''environnement EMS ! (',reg.AH,')');

end;


procedure EmsClose;
var reg : registers;
begin
  ExitProc := SaveExit;
  { -------------------------
    Libere la memoire alloue
    ------------------------- }
  reg.AH := $45;
  reg.DX := EMSHandle;
  Intr(IntrEMS,reg);
end;


{ -------------------------
  Initialise l'environement
  ------------------------- }
procedure LaunchSys;
var i : word;
begin
  { -----------------------------
    Correction du nombre de tche
    ----------------------------- }
  if NbTask<=0 then NbTask := 1
  else
    if NbTask>LgTabTask then NbTask := LgTabTask;

  { -------------------------------------
    Correction sur la longueur de la pile
    ------------------------------------- }
  LgStack := (LgStack+15) and not(15);
  if LgStack<4096 then LgStack := 4096      { --- 4 Ko minimun }
  else
    if LgStack>28672 then LgStack := 28672;  { --- 28 Ko maximun }

  { ----------------------
    Initialisation mmoire
         (ou non)
    ---------------------- }
  if EmsOpen then
    begin
      { --------------------------------------
        Initialisation des tches potentielles
        -------------------------------------- }
      for i := 0 to NbTask-1 do
        begin
          FillChar(TabTask[i],sizeof(TabTask[i]),0);
          TabTask[i].St := TaskOFF;
        end;

      { ----------------------------------------------
        Mettre quelques tches en attente de lancement
        ---------------------------------------------- }

      TabTask[1].St := TaskStandBy;
      TabTask[5].St := TaskStandBy;
      TabTask[7].St := TaskStandBy;
      TabTask[8].St := TaskStandBy;


      InitTask0;

      EmsClose;  { --- Liberer la mmoire }
    end;
end;


var p : pointer;
begin
  NbTask    := 10;
  LgStack   := 8192;
  LcGranule := (1 shl 4)-1;   { 0=>0, 1=>1, 2=>3, 3=>7, 4=>15 ... 7=>127 }

  writeln('Tasks Simulator III');
  LaunchSys;
end.
